Index: branches/cd/src/lib/collision_detection/obb_tree_node.cc
===================================================================
--- branches/cd/src/lib/collision_detection/obb_tree_node.cc	(revision 7660)
+++ branches/cd/src/lib/collision_detection/obb_tree_node.cc	(revision 7665)
@@ -131,5 +131,6 @@
     for(int j = 0; j < 3; ++j)
     {
-      PRINTF(2)("  vertex[%i]: %f, %f, %f\n", j, (&modelInf.pVertices[modelInf.pTriangles[triangleIndexes[i]].indexToVertices[j]])[0],
+      PRINTF(2)("  vertex[%i]: %f, %f, %f\n", j,
+      (&modelInf.pVertices[modelInf.pTriangles[triangleIndexes[i]].indexToVertices[j]])[0],
       (&modelInf.pVertices[modelInf.pTriangles[triangleIndexes[i]].indexToVertices[j]])[1],
       (&modelInf.pVertices[modelInf.pTriangles[triangleIndexes[i]].indexToVertices[j]])[2]);
@@ -137,4 +138,9 @@
   }
 
+  PRINT(0)("\n\n\n");
+  for( int i = 0; i < this->bvElement->modelInf->numVertices*3; i+=3)
+    PRINTF(0)(  "vertex[%i]: %f, %f, %f\n", i, this->bvElement->modelInf->pVertices[i],
+               this->bvElement->modelInf->pVertices[i+1],
+               this->bvElement->modelInf->pVertices[i+2]);
 
 
@@ -280,7 +286,7 @@
   /* calculate the axis */
   covMat.getEigenVectors(axis[0], axis[1], axis[2] );
-  box.axis[0] = axis[0];
-  box.axis[1] = axis[1];
-  box.axis[2] = axis[2];
+//   box.axis[0] = axis[0];
+//   box.axis[1] = axis[1];
+//   box.axis[2] = axis[2];
 
   box.axis[0] = Vector(1,0,0);
@@ -319,6 +325,4 @@
   float               centerOffset[3];
 
-
-
   /* get the maximal dimensions of the body in all directions */
   /* for the initialisation the value just has to be inside of the polygon soup -> first vertices (rand) */
@@ -335,5 +339,5 @@
     maxLength[k] = p->distancePoint(tmpVec);
     minLength[k] = p->distancePoint(tmpVec);
-
+    PRINT(0)("axis[%i]: %f %f %f\n", k, box.axis[k].x, box.axis[k].y, box.axis[k].z);
 
     for( int j = 0; j < length; ++j) {
@@ -341,4 +345,8 @@
         tmpVec = &modelInf.pVertices[modelInf.pTriangles[triangleIndexes[j]].indexToVertices[i]];
         tmpLength = p->distancePoint(tmpVec);
+        PRINT(0)("vertex normal vec: %i, (%f, %f, %f) distance = %f\n", k, (&modelInf.pVertices[modelInf.pTriangles[triangleIndexes[j]].indexToVertices[i]])[0],
+        (&modelInf.pVertices[modelInf.pTriangles[triangleIndexes[j]].indexToVertices[i]])[1],
+        (&modelInf.pVertices[modelInf.pTriangles[triangleIndexes[j]].indexToVertices[i]])[2],
+        tmpLength);
         if( tmpLength > maxLength[k])
           maxLength[k] = tmpLength;
@@ -393,5 +401,4 @@
   }
 
-  // FIXME: += anstatt -= ????????? verwirr
   box.center.x += centerOffset[0];
   box.center.y += centerOffset[1];
@@ -710,8 +717,20 @@
         glBegin(GL_POINTS);
         glColor3f(0.3, 0.8, 0.54);
-        for( int i = 0; i < this->bvElement->modelInf->numVertices*3; i+=3)
-          glVertex3f(this->bvElement->modelInf->pVertices[i],
-                     this->bvElement->modelInf->pVertices[i+1],
-                     this->bvElement->modelInf->pVertices[i+2]);
+        for( int i = 0; i < this->bvElement->modelInf->numTriangles; ++i)
+        {
+          PRINTF(2)("triangle[%i]\n", i);
+          for(int j = 0; j < 3; ++j)
+          {
+            glVertex3f(
+                (&this->bvElement->modelInf->pVertices[this->bvElement->modelInf->pTriangles[i].indexToVertices[j]])[0],
+                (&this->bvElement->modelInf->pVertices[this->bvElement->modelInf->pTriangles[i].indexToVertices[j]])[1],
+                (&this->bvElement->modelInf->pVertices[this->bvElement->modelInf->pTriangles[i].indexToVertices[j]])[2]);
+          }
+        }
+
+//         for( int i = 0; i < this->bvElement->modelInf->numVertices*3; i+=3)
+//           glVertex3f(this->bvElement->modelInf->pVertices[i],
+//                      this->bvElement->modelInf->pVertices[i+1],
+//                      this->bvElement->modelInf->pVertices[i+2]);
         glEnd();
       }
Index: branches/cd/src/subprojects/collision_detection/collision_detection.cc
===================================================================
--- branches/cd/src/subprojects/collision_detection/collision_detection.cc	(revision 7660)
+++ branches/cd/src/subprojects/collision_detection/collision_detection.cc	(revision 7665)
@@ -267,5 +267,5 @@
   while( entity != NULL)
   {
-    //if( likely(drawModel))
+    if( likely(drawModel))
       entity->draw();
     entity->drawBVTree(depth, drawMode);