Index: branches/atmospheric_engine/src/lib/graphics/Makefile.am
===================================================================
--- branches/atmospheric_engine/src/lib/graphics/Makefile.am	(revision 7652)
+++ branches/atmospheric_engine/src/lib/graphics/Makefile.am	(revision 7679)
@@ -24,4 +24,6 @@
 			   effects/rain_effect.cc \
 			   effects/snow_effect.cc \
+			   effects/cloud_effect.cc \
+			   effects/lightening_effect.cc \
 			   effects/lense_flare.cc
 
@@ -48,4 +50,6 @@
 		 effects/rain_effect.h \
 		 effects/snow_effect.h \
+		 effects/cloud_effect.h \
+		 effects/lightening_effect.h \
 		 effects/lense_flare.h
 
Index: branches/atmospheric_engine/src/lib/graphics/effects/cloud_effect.cc
===================================================================
--- branches/atmospheric_engine/src/lib/graphics/effects/cloud_effect.cc	(revision 7679)
+++ branches/atmospheric_engine/src/lib/graphics/effects/cloud_effect.cc	(revision 7679)
@@ -0,0 +1,70 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+### File Specific:
+   main-programmer: hdavid, amaechler
+*/
+
+#include "cloud_effect.h"
+
+#include "util/loading/load_param.h"
+#include "util/loading/factory.h"
+
+#include "glincl.h"
+
+#include "parser/tinyxml/tinyxml.h"
+
+using namespace std;
+
+CREATE_FACTORY(CloudEffect, CL_CLOUD_EFFECT);
+
+CloudEffect::CloudEffect(const TiXmlElement* root)
+{
+	this->setClassID(CL_CLOUD_EFFECT, "CloudEffect");
+
+	this->init();
+
+	if (root != NULL)
+		this->loadParams(root);
+
+	this->activate();
+}
+
+CloudEffect::~CloudEffect()
+{
+	this->deactivate();
+}
+
+void CloudEffect::loadParams(const TiXmlElement* root)
+{
+	WeatherEffect::loadParams(root);
+}
+
+
+bool CloudEffect::init()
+{
+	//Default values
+}
+
+bool CloudEffect::activate()
+{
+	PRINTF(0)( "Activating CloudEffect ");
+}
+
+
+bool CloudEffect::deactivate()
+{
+	PRINTF(0)("Deactivating CloudEffect\n");
+}
+
+void CloudEffect::tick (float dt)
+{
+
+}
Index: branches/atmospheric_engine/src/lib/graphics/effects/cloud_effect.h
===================================================================
--- branches/atmospheric_engine/src/lib/graphics/effects/cloud_effect.h	(revision 7679)
+++ branches/atmospheric_engine/src/lib/graphics/effects/cloud_effect.h	(revision 7679)
@@ -0,0 +1,36 @@
+/**
+* @file cloud_effect.h
+*/
+
+#ifndef _CLOUD_EFFECT
+#define _CLOUD_EFFECT
+
+#include "vector.h"
+#include "vector2D.h"
+
+#include "weather_effect.h"
+
+#include "sound_buffer.h"
+#include "sound_source.h"
+
+class CloudEffect : public WeatherEffect
+{
+	public:
+		CloudEffect(const TiXmlElement* root = NULL);
+		virtual ~CloudEffect();
+
+		virtual void loadParams(const TiXmlElement* root);
+
+		virtual bool init();
+
+		virtual bool activate();
+		virtual bool deactivate();
+
+		virtual void tick(float dt);
+
+		
+	private:
+		
+};
+
+#endif  /* _CLOUD_EFFECT */
Index: branches/atmospheric_engine/src/lib/graphics/effects/lightening_effect.cc
===================================================================
--- branches/atmospheric_engine/src/lib/graphics/effects/lightening_effect.cc	(revision 7679)
+++ branches/atmospheric_engine/src/lib/graphics/effects/lightening_effect.cc	(revision 7679)
@@ -0,0 +1,71 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+### File Specific:
+   main-programmer: hdavid, amaechler
+*/
+
+#include "lightening_effect.h"
+
+#include "util/loading/load_param.h"
+#include "util/loading/factory.h"
+
+#include "glincl.h"
+#include "parser/tinyxml/tinyxml.h"
+
+using namespace std;
+
+CREATE_FACTORY(LighteningEffect, CL_LIGHTENING_EFFECT);
+
+LighteningEffect::LighteningEffect(const TiXmlElement* root)
+{
+	this->setClassID(CL_LIGHTENING_EFFECT, "LighteningEffect");
+
+	this->init();
+
+	if (root != NULL)
+		this->loadParams(root);
+
+	this->activate();
+}
+
+LighteningEffect::~LighteningEffect()
+{
+	this->deactivate();
+}
+
+void LighteningEffect::loadParams(const TiXmlElement* root)
+{
+	WeatherEffect::loadParams(root);
+}
+
+
+bool LighteningEffect::init()
+{
+	//Default values
+}
+
+
+bool LighteningEffect::activate()
+{
+	PRINTF(0)( "Activating LighteningEffect" );
+
+}
+
+
+bool LighteningEffect::deactivate()
+{
+	PRINTF(0)("Deactivating LighteningEffect\n");
+}
+
+void LighteningEffect::tick (float dt)
+{
+
+}
Index: branches/atmospheric_engine/src/lib/graphics/effects/lightening_effect.h
===================================================================
--- branches/atmospheric_engine/src/lib/graphics/effects/lightening_effect.h	(revision 7679)
+++ branches/atmospheric_engine/src/lib/graphics/effects/lightening_effect.h	(revision 7679)
@@ -0,0 +1,36 @@
+/**
+* @file lightening_effect.h
+*/
+
+#ifndef _LIGHTENING_EFFECT
+#define _LIGHTENING_EFFECT
+
+#include "vector.h"
+#include "vector2D.h"
+
+#include "weather_effect.h"
+
+#include "sound_buffer.h"
+#include "sound_source.h"
+
+
+class LighteningEffect : public WeatherEffect
+{
+	public:
+		LighteningEffect(const TiXmlElement* root = NULL);
+		virtual ~LighteningEffect();
+
+		virtual void loadParams(const TiXmlElement* root);
+
+		virtual bool init();
+
+		virtual bool activate();
+		virtual bool deactivate();
+
+		virtual void tick(float dt);
+
+	private:
+
+};
+
+#endif  /* _LIGHTENING_EFFECT */